package org.idealab.learn.nio;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.nio.ByteBuffer;
import java.nio.channels.SelectionKey;
import java.nio.channels.Selector;
import java.nio.channels.ServerSocketChannel;
import java.nio.channels.SocketChannel;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

public class EchoServer {

	// С
	private static final int BUFFER_SIZE = 1024 * 5;

	// ʱʱ䣬λ
	private static final int TIME_OUT = 3000;

	// ؼ˿
	private static final int LISTENING_PORT = 2015;

	private static final boolean RUNNING = true;

	public static void main(String[] args) throws IOException {
		Selector selector = Selector.open();
		ServerSocketChannel ssc = ServerSocketChannel.open();
		ssc.socket().bind(new InetSocketAddress(LISTENING_PORT));
		ssc.configureBlocking(false);

		ssc.register(selector, SelectionKey.OP_ACCEPT);

		// ѭ,ȴIO
		while (RUNNING) {
			int num = selector.select(TIME_OUT);
			if (num == 0) {
				continue;
			}

			Iterator<SelectionKey> keyIter = selector.selectedKeys().iterator();

			while (keyIter.hasNext()) {
				SelectionKey key = keyIter.next();
				try {
					process(key);
				} catch (IOException e) {
					e.printStackTrace();
				}
				// Ƴļ
				keyIter.remove();
			}
		}
	}

	/**
	 * process.
	 * 
	 * @param key
	 * @throws IOException
	 */
	private static void process(SelectionKey key) throws IOException {
		// ӣעᵽͬһselector
		// ʵʵϵͳӵʹһselectorдʹһselectorֱڲͬ߳
		// ѭselector.select();
		if (key.isAcceptable()) {
			SocketChannel clientChannel = ((ServerSocketChannel) key.channel()).accept();
			clientChannel.configureBlocking(false);
			clientChannel.register(key.selector(), SelectionKey.OP_READ);
			return;
		}
		if (key.isReadable()) {
			// ͻͨŵŵ
			SocketChannel clientChannel = (SocketChannel) key.channel();
			List<ByteBuffer> buffers = new ArrayList<ByteBuffer>();
			ByteBuffer buffer = null;
			int bytesRead = 0;
			int bytesTotalRead = 0;
			// ѭȡΪֻΪ5KĴ5KҪζȡ
			while (true) {
				buffer = ByteBuffer.allocate(BUFFER_SIZE);
				bytesRead = clientChannel.read(buffer);
				if (bytesRead > 0) {
					buffers.add(buffer);
					bytesTotalRead += bytesRead;
				} else if (bytesRead == 0) {
					// 0ʾȡ˵SocketChannelûйر
					break;
				} else { // -1ʾȡ˶ҿͻSocketChannelر
					// clientChannel.close();
					break;
				}
			}
			byte[] data = new byte[bytesTotalRead];
			int startIndex = 0;
			for (ByteBuffer bf : buffers) {
				bf.flip();
				System.arraycopy(bf.array(), 0, data, startIndex, bf.remaining());
				startIndex += bf.remaining();
			}

			String message = new String(data, "UTF-8");

			// ̨ӡյϢ
			System.out.println("յ" + clientChannel.socket().getRemoteSocketAddress() + "Ϣ:" + message);

			// յϢظͻ
			String sendString = ",ͻ. @" + new Date().toString() + "ѾյϢ:" + message;
			buffer = ByteBuffer.wrap(sendString.getBytes("UTF-8"));
			clientChannel.write(buffer);
			
			clientChannel.close(); // Ϣֱӹرsocket
			return;
		}

		if (key.isReadable()) {
		}
	}
}
