package org.alive.tools.socketmessage;

import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.channels.SelectionKey;
import java.nio.channels.Selector;
import java.nio.channels.SocketChannel;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * ȡϢ̣߳ΪʹõķʽIOҪڵ߳жȡͬʱҲΪ˷UI
 * 
 * @author XUHAILIN730
 * 
 */
public class ReadMessageTask implements Runnable {

	private Selector selector;

	private UIUpdater updater;

	private String encoding;

	private boolean running = true;

	private int timeout = 0;

	public ReadMessageTask(Selector selector, UIUpdater updater, String encoding) {
		super();
		this.selector = selector;
		this.updater = updater;
		this.encoding = encoding;
	}

	public void run() {
		while (running && timeout < 10) {
			try {
				int num = selector.select(1000);
				if (num == 0) {
					timeout++;
					continue;
				}
			} catch (IOException e) {
				e.printStackTrace();
				continue;
			}

			// ȡõ.selectedKeys()аÿ׼ĳһI/OŵSelectionKey
			Iterator<SelectionKey> keyIter = selector.selectedKeys().iterator();

			while (keyIter.hasNext()) {
				SelectionKey key = keyIter.next();
				if (key.isReadable()) {
					SocketChannel sc = null;
					try {
						sc = (SocketChannel) key.channel();
						int bufferSize = 1024 * 10; // 10KB read buffer
						ByteBuffer buf = ByteBuffer.allocate(bufferSize);
						List<ByteBuffer> buffers = new ArrayList<ByteBuffer>();

						int bytesRead = 0;
						int totalBytesRead = 0;

						bytesRead = sc.read(buf);
						while (bytesRead > 0) {
							buffers.add(buf);
							buf = ByteBuffer.allocate(bufferSize);
							totalBytesRead += bytesRead;
							bytesRead = sc.read(buf);
						}

						final byte[] data = new byte[totalBytesRead];
						int startIndex = 0;
						for (ByteBuffer bf : buffers) {
							bf.flip();
							System.arraycopy(bf.array(), 0, data, startIndex,
									bf.remaining());
							startIndex += bf.remaining();
						}

						String receivedString = new String(data, encoding);
						// UI
						updater.update("responseMessage",
								new Object[] { receivedString });
						updater.update("statusMsg", new Object[] { "յӦ.." });

						/**
						 * int iReadBytes = sc.read(buffer); if (iReadBytes !=
						 * -1) { buffer.flip();
						 * 
						 * // ֽתΪΪUTF-8ַ final String receivedString =
						 * Charset .forName("UTF-8").newDecoder()
						 * .decode(buffer).toString();
						 * 
						 * // UI SwingUtilities.invokeLater(new Runnable() {
						 * public void run() {
						 * responseMessage.setText(receivedString);
						 * statusMsg.setText("յӦ.."); } }); }
						 */
					} catch (IOException e) {
						e.printStackTrace();
						updater.update("statusMsg", new Object[] { "쳣" + e.getMessage() });
					} finally {
						if (sc != null) {
							try {
								sc.close();
							} catch (IOException e) {
								e.printStackTrace();
							}
						}
						running = false;
					}
				}

				// remove
				keyIter.remove();
			}
		}
		
		// رSelector
		if (this.selector != null) {
			try {
				this.selector.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		
		if (timeout == 10) {
			updater.update("statusMsg", new Object[] { "ʱ.." });
		}
	}
}
