package org.alive.tools.socketmessage;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.nio.ByteBuffer;
import java.nio.channels.SelectionKey;
import java.nio.channels.Selector;
import java.nio.channels.SocketChannel;

/**
 * ̣߳ʼSocketӣReadMessageTask߳׼ȡӦϢϢҪʱUI
 * 
 * @author XUHAILIN730
 * 
 */
public class WorkerTask implements Runnable {

	private String ip;

	private int port;

	private String request;

	private String encoding;

	private int headLen;

	private UIUpdater updater;

	public WorkerTask(String ip, int port, String request, String encoding,
			int headLen, UIUpdater updater) {
		super();
		this.ip = ip;
		this.port = port;
		this.request = request;
		this.encoding = encoding;
		this.headLen = headLen;
		this.updater = updater;
	}

	public void run() {

		SocketChannel sc = null;
		try {
			sc = SocketChannel.open(new InetSocketAddress(ip, port));
			sc.configureBlocking(false);
			sc.socket().setTcpNoDelay(true);
			sc.socket().setReuseAddress(true);
			Selector selector = Selector.open();
			sc.register(selector, SelectionKey.OP_READ);
			// ȡӦ߳
			new Thread(new ReadMessageTask(selector, updater, encoding), "ReadMessageThread").start();

			updater.update("statusMsg", new Object[] { ".." });
			// ϢעReadMessageTask֮߳ԷֹReadMessageTask̻߳ûӦϢͷͻ
			byte[] data = request.getBytes(encoding);
			// ϢȷŵϢͷ00001342<xml ...>
			String msgHead = String.valueOf(data.length);
			for (int i = msgHead.length(); i < headLen; i++) {
				msgHead = "0" + msgHead;
			}
			updater.update("lengthMsg", new Object[] { "Ϣ" + msgHead });

			ByteBuffer writeBuffer = ByteBuffer.allocate(headLen + data.length);
			if (headLen > 0) {
				byte[] head = msgHead.getBytes(encoding);
				writeBuffer.put(head);
			}
			writeBuffer.put(data);
			writeBuffer.flip(); // flip׼
			sc.write(writeBuffer);

			updater.update("statusMsg", new Object[] { "ѷ.." });
			// SwingUtilities.invokeLater(new Runnable() {
			// public void run() {
			// statusMsg.setText("ѷ..");
			// }
			// });
		} catch (IOException e) {
			e.printStackTrace();
			updater.update("statusMsg", new Object[] { "쳣" + e.getMessage() });
		}
	}
}
